library Step_MA;


uses
  graphics,
  Classes,
  SysUtils,
  IndicatorInterfaceUnit,
  TechnicalFunctions in '..\..\..\..\\Work\StepMA_VVV\TechnicalFunctions.pas',
  math;

var
  //  
  
  Length:integer;                     // Volty Length  = 10;
  Kv:double;                          // Sensivity Factor    = 1.0;
  StepSize:integer;                   // Constant Step Size (if need) = 0;
  MA_Mode:integer;                    // Volty MA Mode : 0-SMA, 1-LWMA    = 0;
  Advance:integer;                    // Offset      = 0;
  Percentage:double;                  // Percentage of Up/Down Moving   = 0;
  HighLow:boolean;                    // High/Low Mode Switch (more sensitive) = false;
  ColorMode:integer;                  // Color Mode Switch     = 0;
  BarsNumber:integer;                 //  = 0;

  //. 
  StepMA:double;
  ATRmax,ATRmin,ATR0:double;


  // 

 LineBuffer,
 UpBuffer,
 DnBuffer,
 smin,
 smax,
 trend:TIndexBuffer;

procedure Init; stdcall;
begin
  //   = ,  ...
  IndicatorShortName('Step_MA');
  SetOutputWindow(ow_ChartWindow);



  //     
  AddSeparator('Common');
  
  RegOption('Length', ot_Integer, Length);
  SetOptionRange('Length', 1, MaxInt);
  Length:=10;

  RegOption('Kv', ot_double, Kv);
  Kv:=1;

  RegOption('StepSize', ot_Integer, StepSize);
  SetOptionRange('StepSize', 1, MaxInt);
  StepSize:=0;

  RegOption('MA_Mode', ot_Integer, MA_Mode);
  SetOptionRange('MA_Mode', 1, MaxInt);
  MA_Mode:=0;

  RegOption('Advance', ot_Integer, Advance);
  SetOptionRange('Advance', 1, MaxInt);
  Advance:=0;

  RegOption('Percentage', ot_double, Percentage);
  SetOptionRange('Percentage', 1, MaxInt);
  Percentage:=0;

  RegOption('HighLow', ot_boolean, HighLow);
  SetOptionRange('HighLow', 1, MaxInt);
  HighLow:=false;

  RegOption('ColorMode', ot_Integer, ColorMode);
  SetOptionRange('ColorMode', 1, MaxInt);
  ColorMode:=0;

  RegOption('BarsNumber', ot_Integer, BarsNumber);
  SetOptionRange('BarsNumber', 1, MaxInt);
  BarsNumber:=0;

  //    . 
   ATRmax:=0;
   ATRmin:=0;
   ATR0:=0;
   StepMA:=0;

  //   

  IndicatorBuffers(6);

 LineBuffer:=createIndexBuffer;
 UpBuffer:=createIndexBuffer;
 DnBuffer:=createIndexBuffer;
 smax:=createIndexBuffer;
 smin:=createIndexBuffer;
 trend:=createIndexBuffer;


  SetIndexBuffer(0,LineBuffer);
  SetIndexStyle(0, ds_Line, psSolid, 2, clBlue);

  end;

 //-------------------

  procedure Done; stdcall;
begin
end;

 //-------------------
                    //   lenght 10   kv          0             index
 function StepSizeCalc(Len:integer; Km:double; Size:integer; k:integer):double;
var
  i:integer;
  AvgRange:double;

begin
    
  if k+Len >= Bars then exit;
      AvgRange:=0;
  for  i:=Len-1 downto 0 do
  AvgRange:=AvgRange+High(k+i)-Low(k+i);
  ATR0:=AvgRange/Len;
  if (ATR0>ATRmax) then ATRmax:=ATR0;
	if (ATR0<ATRmin) then ATRmin:=ATR0;
       
	result:=Round(0.5*Km*(ATRmax+ATRmin)/Point);


end;

{
 procedure Calculate(index: integer); stdcall;
var
 i: integer;
 AvgRange, ATR0, ATRmax, ATRmin, res: double;
begin
 if index + Length >= Bars then
  exit;
 if StepSize = 0 then
  begin
   AvgRange := 0;
   for i:=Length - 1 downto 0 do
    AvgRange := AvgRange + High(index + i) - Low(index + i);
   ATR0 := AvgRange/Length;
   if (ATR0 > ATRmax) then ATRmax := ATR0;
   if (ATR0 < ATRmin) then ATRmin := ATR0;
   res := Round(0.5*Kv*(ATRmax + ATRmin)/Point);
  end
 else
  res := Kv*StepSize;
 buff[index] := res;
end;

       }

//-------------------

function StepMACalc (HL:boolean; Size:double; k:integer):double;


begin

 if (HL) then
 begin
  smax[k]:=Low(k)+2*Size*Point;
  smin[k]:=High(k)-2*Size*Point;
 end
 else
 begin
  smax[k]:=close(k)+2*Size*Point;  //    
  smin[k]:=close(k)-2*Size*Point;
 end;

 trend[k]:=trend[k+1];

 if (Close(k)>smax[k+1]) then trend[k]:=1;   //  
 if (Close(k)<smin[k+1]) then trend[k]:=-1;

   if(trend[k]>0) then // 
   begin
	  if(smin[k]<smin[k+1]) then    //       
	   smin[k]:=smin[k+1];
	  result:=smin[k]+Size*Point;   // 
   end
   else
   begin
    if(smax[k]>smax[k+1]) then
     smax[k]:=smax[k+1];   //     
    result:=smax[k]-Size*Point;
   end;

end;


//-------------------

  procedure Calculate(index: integer); stdcall;
var
 shift:integer;
 Step:double;

begin
   shift:=index;
   begin
   Step := StepSizeCalc( Length, Kv, StepSize, shift);
// Step :=23;
   StepMA := StepMACalc(HighLow, Step, shift)+Percentage/100*Step*Point;

   LineBuffer[index]:=StepMA;

   end;
end;

exports

  Init, Done, Calculate;

end.


    //===================================
















 //+------------------------------------------------------------------+
//|                                                    StepMA_v7.mq4 |
//|                                Copyright  2006, TrendLaboratory |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, TrendLaboratory"
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Aqua
#property indicator_color2 Blue
#property indicator_color3 Red

//---- input parameters
extern int     Length      = 10;      // Volty Length
extern double  Kv          = 1.0;     // Sensivity Factor
extern int     StepSize    = 0;       // Constant Step Size (if need)
extern int     MA_Mode     = 0;       // Volty MA Mode : 0-SMA, 1-LWMA 
extern int     Advance     = 0;       // Offset
extern double  Percentage  = 0;       // Percentage of Up/Down Moving   
extern bool    HighLow     = false;   // High/Low Mode Switch (more sensitive)
extern int     ColorMode   = 0;       // Color Mode Switch
extern int     BarsNumber  = 0;       

//---- indicator buffers
double LineBuffer[];
double UpBuffer[];
double DnBuffer[];
double smin[];
double smax[];
double trend[];

double StepMA=0, ATR0=0,ATRmax=-100000,ATRmin=1000000;

int limit;

//---- StepSize Calculation


                        Length= 10;   Kv= 1.0;    StepSize= 0;   shift
   double StepSizeCalc ( int Len,     double Km,  int Size,      int k)
   {

   double result;
   if( Size==0 )
   {
        double AvgRange=0;
	     for (int i=Len-1;i>=0;i--)
	     { 
            if(MA_Mode==0) double alfa= 1.0; else alfa= 1.0+1.0*(Len-i)/Len; 
            AvgRange+= alfa*(High[k+i]-Low[k+i]);
        }

	     ATR0 = AvgRange/Len;
	
	if (ATR0>ATRmax) ATRmax=ATR0;
	if (ATR0<ATRmin) ATRmin=ATR0;
	
	result=MathRound(0.5*Km*(ATRmax+ATRmin)/Point); 
	}
	else
	result=Km*StepSize;
   
   return(result);
   }

//---- StepMA Calculation   
   
   double StepMACalc (bool HL, double Size, int k)
   {
   int counted_bars=IndicatorCounted();
   double result;
   
   if (HL)
	  {
	  smax[k]=Low[k]+2.0*Size*Point;
	  smin[k]=High[k]-2.0*Size*Point;
     } 	
	else  	 
	  {
	  smax[k]=Close[k]+2.0*Size*Point;
	  smin[k]=Close[k]-2.0*Size*Point;
	  }
	  if (counted_bars==0){smax[limit+1]=smax[limit];smin[limit+1]=smin[limit];trend[limit+1]=0;}
	  
	  trend[k]=trend[k+1];   
	  
	  if (Close[k]>smax[k+1]) trend[k]=1;   
	 
	  if (Close[k]<smin[k+1]) trend[k]=-1;  
	 
	  if(trend[k]>0)
	  {
	  if(smin[k]<smin[k+1]) smin[k]=smin[k+1];
	  result=smin[k]+Size*Point;
	  } 
	  else
	  {
	  if(smax[k]>smax[k+1]) smax[k]=smax[k+1];
	  result=smax[k]-Size*Point;
	  }
     //Print (" k=",k," trend=",trend[k], " res=",result," Smax=", smax[k], " Smin=", smin[k]);
	  
     
     return(result); 
     } 
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
  int init()
  {
   string short_name;
//---- indicator line
   IndicatorBuffers(6);
   
   SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,2);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexStyle(2,DRAW_LINE);
   
   SetIndexArrow(1,159);
   SetIndexArrow(2,159);
   
   SetIndexBuffer(0,LineBuffer);
   SetIndexBuffer(1,UpBuffer);
   SetIndexBuffer(2,DnBuffer);
   
   SetIndexShift(0,Advance);
   SetIndexShift(1,Advance);
   SetIndexShift(2,Advance);
   
   SetIndexBuffer(3,smin);
   SetIndexBuffer(4,smax);
   SetIndexBuffer(5,trend);
   
//---- name for DataWindow and indicator subwindow label
   short_name="StepMA("+Length+","+Kv+","+StepSize+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
   SetIndexLabel(1,"UpTrend");
   SetIndexLabel(2,"DownTrend"); 
//----
   SetIndexDrawBegin(0,Length);
   SetIndexDrawBegin(1,Length);
   SetIndexDrawBegin(2,Length);
//----
   return(0);
   }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }     
//+------------------------------------------------------------------+
//| StepMA_v7                                                        |
//+------------------------------------------------------------------+
int start()
  {
   int shift, counted_bars=IndicatoshiftrCounted();

   if ( BarsNumber > 0 ) int Nbars=BarsNumber; else Nbars=Bars;
   if ( counted_bars > 0 )  limit=Nbars-counted_bars;
   if ( counted_bars < 0 )  return(0);
   if ( counted_bars ==0 )  limit=Nbars-Length-1;
      
	for(shift=limit;shift>=0;shift--) 
   {

	int Step = StepSizeCalc( Length, Kv, StepSize, );
				
	Comment (" StepSize= ", Step);
	
	StepMA = StepMACalc ( HighLow, Step, shift)+Percentage/100.0*Step*Point;
	
	Comment (" StepSizmAe= ", StepMA);
	
	if ( ColorMode == 0) LineBuffer[shift]=StepMA;
	
	if ( ColorMode == 1)
	{
	if ( trend[shift]>0 ) {UpBuffer[shift]=StepMA-Step*Point;DnBuffer[shift]=EMPTY_VALUE;}
	else
	if ( trend[shift]<0 ) {DnBuffer[shift]=StepMA+Step*Point;UpBuffer[shift]=EMPTY_VALUE;}
	}
	else
	if ( ColorMode == 2)
	{
	if (trend[shift]>0) 
	  {
	  UpBuffer[shift]=StepMA;
	  if ( trend[shift+1] < 0 ) UpBuffer[shift+1] = DnBuffer[shift+1];
	  DnBuffer[shift]=EMPTY_VALUE;
	  }
	  if (trend[shift]<0) 
	  {
	  DnBuffer[shift]=StepMA;
	  if ( trend[shift+1] > 0 ) DnBuffer[shift+1] = UpBuffer[shift+1];
	  UpBuffer[shift]=EMPTY_VALUE;
	  }
	}
	else
	{	
	UpBuffer[shift]=EMPTY_VALUE; DnBuffer[shift]=EMPTY_VALUE;
	}
	
	}
	return(0);	
 }
  
